#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

/*pnt queda definido como struct point */
/* dos maneras de hacerlo*/
struct point{
  int x;
  int y;
};
typedef struct point pnt; 

/* esta forma es mas compacta pues hago a la vez la definici[on de la
 estructura y el typedef:

typedef struct point{
  int x;
  int y;
} pnt;
*/


#define LINS 3
#define COLS 3

double diagonal(pnt pt1, pnt pt2);
enum BOOL {FALSE,TRUE};

int main(int argc, char* argv[]){
  pnt pt;     /* es lo mismo que struct point pt;*/
  pnt * ppt;  /* es lo mismo que struct point * ppt;*/
  struct rect {
    struct point vertice1;
    struct point vertice2;
  };
  struct rect pantalla;
  int valor,i,j;
  pnt *screen;
  pnt imagen[LINS][COLS];

  for (i=0;i<LINS;i++){
    for (j=0;j<COLS;j++){
      imagen[i][j].x = i;
      imagen[i][j].y = j;
    }
  }
  for (i=0;i<LINS;i++){
    for (j=0;j<COLS;j++){
      printf("imagen[%d][%d] = (%d,%d) ",i,j, imagen[i][j].x, imagen[i][j].y);
    }
    printf("\n");
  }
  printf("\n");
  
  pt.x = pt.y = 0;
  ppt = &pt;
  if (argc < 2){
    printf("uso ./estructuras [x] [y]\n");
    printf("donde [x] y [y] son enteros\n");
  }
  if (argc == 3){
    pt.x = atoi(argv[1]);
    pt.y = atoi(argv[2]);
  }
  printf("pt (%d,%d)\n",pt.x,pt.y);
  printf("ppt (%d,%d)\n",ppt->x,ppt->y); /* uso la flecha cuando es puntero*/
  pantalla.vertice1.x = 0;
  pantalla.vertice1.y = 0;
  pantalla.vertice2.x = pt.x;
  pantalla.vertice2.y = pt.y;
  double diag = diagonal(pantalla.vertice1, pantalla.vertice2);
  
  printf("diagonal de la pantalla es %f\n",diag);
  valor = (pt.x == pt.y) ? TRUE : FALSE;
  if (valor)
    printf("coordenadas iguales\n");
  else
    printf("coordenadas desiguales\n");

  int dx = pt.x;
  int dy = pt.y; 
  screen = (pnt *)malloc(sizeof(pnt)*dx*dy);
printf("memoria reservada %ld dx %d dy %d sizeof(pnt) %ld\n",sizeof(pnt)*dx*dy,dx, dy, sizeof(pnt));
  for (i=0;i<dx;i++){
    for (j=0;j<dy;j++){
      screen[i*dy+j].x = i;
      screen[i*dy+j].y = j;
    }
  }
  for (i=0;i<dx;i++){
    for (j=0;j<dy;j++){
      printf("screen[%d][%d] = (%d,%d) ",i,j, screen[i*dy+j].x,screen[i*dy+j].y);
    }
    printf("\n");
  }
  printf("\n");

  free(screen);

  return 0;
}

double diagonal(pnt pt1, pnt pt2){
  double dx,dy;
  dx = pt2.x - pt1.x;
  dy = pt2.y - pt1.y;
  return((double)(sqrt(dx*dx + dy*dy)));
}
